// 012 u_interbase_blobs_ascii
// 30 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_interbase_blobs_ascii;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, ExtCtrls,
      Db, DBTables, Grids, DBGrids, DBCtrls, ComCtrls;

    type TForm1 = class(TForm)
    Database1: TDatabase;
    Query1: TQuery;
    DataSource1: TDataSource;
    Panel1: TPanel;
    create_table_: TButton;
    drop_table_: TButton;
    insert_many_with_stream_: TButton;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    select_all_: TButton;
    DBMemo1: TDBMemo;
                    procedure FormCreate(Sender: TObject);
    procedure create_table_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure insert_many_with_stream_Click(Sender: TObject);
    procedure select_all_Click(Sender: TObject);
                    private
                    public
                  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display
      , u_file;

    {$R *.DFM}

    
    const k_log_path= 'log\';
            k_log_name= 'log_interbase_blobs_ascii.txt';

          k_file_path= '..\blobs_interbase\data_for_blob\';
            k_load_file_name= 'formations.txt';
            k_formation_interbase= 'formation_interbase.txt';
            k_save_file_name= 'save_formations.txt';

          k_table_name= 'client_ascii';  

    // -- procedures

    procedure insert_with_stream_ascii(p_id: Integer; p_c_stream: tStream);
      begin
        display('Stream.Position: '+ IntToStr(p_c_stream.Position));
        display('Stream_size: '+ IntToStr(p_c_stream.Size));
        with Form1, Query1, Sql do
        begin
          Clear;

          Add('INSERT INTO '+ k_table_name+ ' (c_id, c_ascii)');
          Add('  VALUES ('+ IntToStr(p_id)+ ', :c_ascii'+ ')');

          ParamByName('c_ascii').LoadFromStream(p_c_stream, ftMemo);

          ExecSql;
        end; // with Query1, Sql
        display_strings(Form1.Query1.Sql);
        display('Stream.Position: '+ IntToStr(p_c_stream.Position));
      end; // insert_with_stream_ascii

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_display_log(k_log_path+ k_log_name);
      end; // FormCreate

    procedure TForm1.create_table_Click(Sender: TObject);
      begin
        with Query1, Sql do
        begin
          Close;
          Clear;
          Add('CREATE TABLE '+ k_table_name);
          Add('   (                         ');
          Add('       c_id NUMERIC(5) NOT NULL PRIMARY KEY');
          Add('     , c_ascii BLOB SUB_TYPE 1');
          Add('   )                         ');

          ExecSql;
        end; // with Query1, Sql

        display_line;
        display_strings(Query1.Sql);
      end; // create_table_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        with Query1, Sql do
        begin
          Close;
          Clear;
          Add('DROP TABLE '+ k_table_name);

          ExecSql;
        end; // with Query1, Sql

        display_line;
        display_strings(Query1.Sql);
      end; // drop_table_Click

    // -- files

    procedure TForm1.insert_many_with_stream_Click(Sender: TObject);
      var l_c_string_list: tStringList;
          l_id: Integer;
          l_line: String;
          l_c_string_stream: tStringStream;
      begin
        l_c_string_list:= tStringList.Create;
        l_c_string_list.LoadFromFile(k_file_path+ 'formation_interbase.txt');

        for l_id:= 0 to l_c_string_list.Count- 1 do
        begin
          l_line:= l_c_string_list[l_id];
          l_c_string_stream:= tStringStream.Create(l_line);
          insert_with_stream_ascii(1000+ l_id, l_c_string_stream);
          l_c_string_stream.Free;
        end;

        l_c_string_list.Free;
      end; // insert_many_with_stream_Click

    procedure TForm1.select_all_Click(Sender: TObject);
      begin
        with Query1, Sql do
        begin
          Close;
          Clear;
          Add('SELECT * FROM '+ k_table_name);
          Open;
        end; // with Query1, Sql
      end; // select_all_Click

    end.


